<?php

include_once './includes/bootstrap.inc';
drupal_bootstrap(DRUPAL_BOOTSTRAP_FULL);
# menu_rebuild();

#---------------------------------------------------------------
# function get_thumb_file  
# http://webthumb.bluga.net/easythumb.php?user=1&url=webthumb.bluga.net%2Fhome&hash=80a171c61c04084ba55cade47ce8d303&size=medium&cache=1
#   * user: Your Webthumb user_id available on your user page
#   * url: Site to thumbnail, make sure to urlencode this
#   * size: Size of the thumbnail to return small, medium1, medium2, large
#   * cache: The # of days old a cached version of the thumbnail can be - 1 to 30
#   * hash: The security hash components are covered below
# The security hash is an md5 hash encoded in hexidecimal containing the following concatenated together
# 
#  * current date: The current date in GMT/UTC formated as YYYYmmdd (in PHP this is the gmdate function)
#  * url: The url to thumbnail not urlencoded
#  * apikey: Your Bluga.net apikey
#---------------------------------------------------------------

function print_info($msg){
  echo "Info: $msg\n";
}

function make_seed()
{
  list($usec, $sec) = explode(' ', microtime());
  return (float) $sec + ((float) $usec * 100000);
}

function _get_thumb_file($url_to_thumb, $bluga_api_key, $bluga_user_id) {
  $user = $bluga_user_id;
  $size = "large";
  $cache = "-1";
  $hash_str = gmstrftime("%Y%m%d") . $url_to_thumb . $bluga_api_key;
  $hash_md5 = md5($hash_str) ;

  $thumb_url = sprintf("http://webthumb.bluga.net/easythumb.php?user=%s&url=%s&hash=%s&size=%s&cache=%s", $user, urlencode($url_to_thumb), $hash_md5, $size, $cache);

  # start download the image
  $path_parts = pathinfo($url_to_thumb);
  $img_ext = strtolower($path_parts['extension']);
  $img_exts = "-jpg-png-gif";
  if(stripos($img_exts, $img_ext) != false ){
    // if url is a image file, download the image directly
    $thumb_url = $url_to_thumb;
  } else {
    $img_ext = "jpg"; //defalut img ext jpg
  }
  $content = file_get_contents($thumb_url);
  $tmp_dir = "tmp";
  $file_name = "$tmp_dir/" . gmstrftime("%Y%m%d%H%M%S") . '.' . $img_ext;
  if(!is_dir($tmp_dir)) mkdir($tmp_dir);
  $bytes_saved = file_put_contents($file_name, $content);
  if($bytes_saved > 0) {
    echo "bytes saved by file_put_contents $bytes_saved \n\n";
    return $file_name;
  } else {
    return "";
  }
}

function get_thumb_file($url_to_thumb, $node_id=0) {
  $bluga_acc_arr = array (
    "5859" => "d9bb60763673c16ffffa1ad5e85a1c94",  #gudonghua
    "6998" => "1b3217d59c40576df61dbfa935d04e9a",  #truevue
    "7072" => "9af04fd806625ebca95d7c08780361e7",  #gwwz1
    "7073" => "b506bbaac127ca316d1be71bf7db77ee",  #gwwz2
    "7090" => "9e52688104a7befac2a13ea9640c8680",  #gwwz3
  );
  $bluga_id_arr = array("5859", "6998", "7072", "7073", "7090");
  $bluga_id_number = count($bluga_id_arr);
  if(!$node_id){
    srand(make_seed());
    $index = rand(0, $bluga_id_number-1);
  }else{
    $index = $node_id % $bluga_id_number;
  }
  # $index = 0;
  $bluga_user_id = $bluga_id_arr[$index];
  $bluga_api_key = $bluga_acc_arr[$bluga_user_id];
  return _get_thumb_file($url_to_thumb, $bluga_api_key, $bluga_user_id);
}

function add_image_to_node($url_to_thumb, $image_des, $node_id, $image_field_name, $reget=false){
  if(! ($url_to_thumb && $image_des && $node_id && $image_field_name)) {
    print_info( "please provide all the parameters!");
    return;
  }
  #$node = node_load(array("nid" => $node_id));
  global $node;
  $node_imagefile_array = $node->$image_field_name;
  if ( isset($node_imagefile_array[0]["filepath"])) {
    # echo "image field $image_field_name file of node $node_id already exists!\n";
  } else {
    # echo "empty $image_field_name\n";
    $src_file_name = get_thumb_file($url_to_thumb, $node_id);
    $file = field_file_save_file($src_file_name, array(), $image_des, FILE_EXISTS_REPLACE);
    # var_dump($file );
    $node->$image_field_name = array(0 => $file);
    node_save($node);
    # var_dump($node->$image_field_name );
    # echo "Info: node_save done\n";
  }
}


$id = $_REQUEST["id"];
$reget = $_REQUEST["reget"];
$img_exts = array( "jpg", "png", "gif");
$img_ext = "jpg";
if(!$id){
  // print_info("You are not supposed to view this page");
  exit;
} 
$node_id = (int)$id;
if($node_id < 1000) {
  exit(0);
}
$node = node_load(array("nid" => $node_id));

if($node->type == "promotion"){
  #promotion node url & image field
  if($node->field_img_url[0]["value"]){
    $url_field_name = "field_img_url";
    $path_parts = pathinfo($node->field_img_url[0]["value"]);
    $img_ext = strtolower($path_parts['extension']);
  } else {
    $url_field_name = "field_url";
  }

  $image_field_name = "field_prom_image";
} elseif ($node->type == "introduction"){
  #introduction node url & image field
  $url_field_name = "field_url";
  $image_field_name = "field_shop_snapshot";
}
  
if($url_field_name && $image_field_name){
  $url_field_array = $node->$url_field_name;
  $url_to_thumb = $url_field_array[0]["value"];
  $des_file_name = gmstrftime("%Y%m%d%H%M%S");
  $des_file_dir = file_directory_path() ."/shop_promo/" . gmstrftime("%Y/%m/%d");
  if(!is_dir($des_file_dir)) mkdir($des_file_dir, 0775,true);
  $des_file_path = $des_file_dir . "/" . "${des_file_name}." . $img_ext; 

  if ( isset($node_imagefile_array[0]["filepath"])) {
    echo "image field $image_field_name file of node $node_id already exists!\n";
  } else {
    add_image_to_node($url_to_thumb, $des_file_path, 
                      $node_id, $image_field_name);
  }
}
